/************************************************************************
**
** FILE  : diwin.H
**
** ZWECK : Private Vereinbarungen fuer die DiWin-Funktionen
**
** AUTOR : Michael C. Ancutici
**	   Universitaet Stuttgart, Fakultaet Informatik
**
** DATUM : 14.03.93
**									
*************************************************************************/
#ifndef DIWIN_HH
#define DIWIN_HH

#include 	<X11/Intrinsic.h>
#include 	<X11/StringDefs.h>
#include	<X11/Shell.h>
#include 	<X11/Xaw/Command.h>
#include 	<X11/Xaw/Form.h>
#include 	<X11/Xaw/AsciiText.h>
#include 	<X11/Xaw/List.h>
#include 	<X11/Xaw/Viewport.h>
#include 	<X11/Xaw/Paned.h>
#include 	<stdio.h>

#include	"diwin.h"

#define DI_FI_TEXT_WIDTH	160		/* Resourcen		*/
#define DI_FI_VIEW_WIDTH	173
#define DI_PA_TEXT_WIDTH	270
#define DI_PA_VIEW_WIDTH	283

#define	DI_PATH_DOESNT_EXIST	1		/* Fehlertypen		*/
#define DI_CLEAR		2
#define DI_CHECK_FOR_CLEAR	DI_CLEAR
#define DI_HERE_WE_ARE		3
#define DI_FILE_DOESNT_EXIST	4
#define DI_CANNOT_WRITE_OVER	5
#define	DI_IS_NO_NETFILE	6

extern DIRECTORY	DirInh;			
extern int		DiOrder;		/* Auftrag Lesen oder Schreiben */
extern int		DiStatWidth;

extern XtAppContext 	AppContext;
extern Widget		DiShell;		/* Shell		*/
extern Widget		DiMaForm;		/* Main Form		*/
extern Widget		DiMaLabel;		/* Main Label		*/
extern Widget		DiFiPaned;		/* File wird einge-Paned*/
extern Widget		DiPaPaned;		/* Pfad wird einge-Paned*/
extern Widget 		DiFiLabel;		/* File Label		*/
extern Widget 		DiFiText;		/* File Name		*/
extern Widget		DiFiView;		/* File Viewport	*/
extern Widget		DiFiList;		/* File List		*/
extern Widget 		DiPaLabel;		/* Pfad Label		*/
extern Widget 		DiPaText;		/* Pfad Name		*/
extern Widget		DiPaView;		/* Pfad Viewport	*/
extern Widget		DiPaList;		/* Pfad List		*/
extern Widget		DiAcCom;		/* OK Button		*/
extern Widget		DiCanCom;		/* Cancel Button	*/
extern Widget		DiStatLabel;		/* Status Label		*/
extern Widget 		DiAcShell;		/* Shell Actionsanzeige	*/


extern void DiMessage( int);	/* Meldung ueber Statuszeile		*/

extern void DiScan();		/* Scannt Verzeichnis			*/

extern void DiCancel( Widget, 	/* wenn CANCEL Button gedrueckt wird	*/
	XtPointer, 
	XtPointer);

extern void DiFiSelect( Widget, /* wenn ein File angeklickt wird	*/
	XtPointer, 
	XtPointer);
	
extern void DiPaSelect( Widget, /* wenn ein Verzeichnis angeklickt wird	*/
	XtPointer, 
	XtPointer);

extern void DiREAD( char *,  	/* wenn gelesen werden soll		*/
	char *);

extern void DiWRITE( char *, 	/* wenn geschrieben werden soll		*/
	char *);

extern void DiAskSayYes( Widget,/* wenn die Sicherheitsabfrage fuer	*/
	XtPointer, 		/* Ueberschreiben mit ja beantwortet wird*/
	XtPointer);

extern void DiAskSayNo( Widget, /* wenn die Sicherheitsabfrage fuer	*/
	XtPointer, 		/* Ueberschreiben mit Nein beantwortet wird*/
	XtPointer);

extern void DiFiAction();	/* wenn File doppelt angeklickt wird oder */
				/* LESEN/SCHREIBEN Button gedrueckt wird  */
				/* oder File von Hand eingegeben wurde	  */
extern void DiPaLoad();		/* wenn Pfad von Hand eigegeben wurde	*/

#endif