/************************************************************************
**
** FILE  : diwin.h
**
** ZWECK : - Oeffentliche Vereinbarungen fuer die DiWin-Funktionen
**
**	   - Dient zur bequemen Bestimmung eines Filenamens, unter dem
**	     dann Daten gespeichert oder gelesen werden.
**	     
**	   - Funktion DiWinPopup
**		Erzeugt und blendet DiShell exclusiv ein.
**		Die linke Liste zeigt die Files an, die sich im Verzeichnis
**		befinden, die rechte den Verzeichnispfad.
**		Das erste mal wird das Verzeichnis angezeigt, aus welchem
**		das Programm gestartet wurde. Das Fenster schliest nachdem
**		gecancelt oder eine Aktion ausgefuehrt wurde. Wenn ein 
**		bereits existierendes File ueberschrieben werden soll,
**		wird zuvor nachgefragt. Das ganze gute Stueck wird im
**		dem Moment des Aufrufens erzeugt. Das erklaert, warum
**		das Fenster nicht wie ein Blitz aufgeht, spart aber Speicher
**		zumal diese Option normalerweise nicht allzuoft bwnutzt
**		wird.
**		 
**	   - Funktion DiWinPopupC
**		Diese Funktion betrifft das Schreiben eines Files.
**		Existiert derzeit ein gueltiger Filename (DirInh.File <> "")
**		wird das File geschrieben. Falls nicht, wird DiWinPopup
**		aufgerufen.
** 
**	   - Funktion DiWinInit
**		Initialisiert private Variable. Muss im Hauptprogramm einmal
**		aufgerufen werden. Wichtig.
**	
**	   - Funktion DiWinPopdown
**		Schliesst DiShell. Wird eigentlich von aussen gar nicht
**		benoetigt.

** AUTOR : Michael C. Ancutici
**	   Universitaet Stuttgart, Fakultaet Informatik
**
** DATUM : 14.03.93
**									
*************************************************************************/
#ifndef DIWIN_H
#define DIWIN_H

#include 	<X11/Intrinsic.h>

#include 	"dir.h"
#include 	"misc.h"

#define DI_READ		1		/* Auftrag File lesen		*/
#define DI_WRITE	0		/* Auftrag File schreiben	*/

extern DIRECTORY	DirInh;

extern void DiWinPopup( 
	Widget, 			/* Eltern-Widget		*/
	XtPointer, 			/* DI_READ oder DI_WRITE	*/
	XtPointer);

extern void DiWinPopupC( 
	Widget, 			/* Eltern-Widget		*/
	XtPointer, 			/* DI_WRITE			*/
	XtPointer);

extern void DiWinInit();

extern void DiWinPopdown();

#endif