/************************************************************************
**
** FILE  : hamem.c
**
** ZWECK : 
**
** AUTOR : Michael C. Ancutici
**	   Universitaet Stuttgart, Fakultaet Informatik
**
** DATUM : 14.03.93
**									
*************************************************************************/
#include	"hamem.h"
#include	"netsize.h"
#include	<stdio.h>
#include	"hawin.h"
#include	"ste.h"
#include	"stetype.h"
#include	"haka.H"
#include	"hastemarke.h"
#include	"simfire.h"
#include	"haka.h"

static int	HaMem[ STEMAX];
static int	HaMemStepNr;




/*************************************************************************
** FUNKTION:	HaMemInit
** ZWECK:	Initialisiert HaMem
*************************************************************************/
void HaMemInit()
{
  register int	*m;
  register int	i;
 
  HaMemStepNr;
 
  for (i=0, m=HaMem; i<STEMAX; i++, m++)
    *m = -1;
   
  BlackGC = XCreateGC( MyDisplay, 
  	HaGraphPixmap,
  	0,0);
 
  XSetForeground( MyDisplay,
  	BlackGC,
  	BlackPixel( MyDisplay, MyScreen) );	 	 

  XSetBackground( MyDisplay,
  	BlackGC,
  	WhitePixel( MyDisplay, MyScreen) );	 	 
}


/*************************************************************************
** FUNKTION:	HaMemSetStepNr
** ZWECK:	Weist HaMemStepNr einen neuen Wert zu und zeigt es an
** EINGABE:	neuer Wert
*************************************************************************/
void HaMemSetStepNr( i)
  int	i;
{  
  STRING	t;

  HaMemStepNr = 0;
  sprintf( t, " %d     ", HaMemStepNr);
  XDrawImageString( MyDisplay, XtWindow(HaMemLabel),
  	BlackGC,
  	4, 12, t, strlen(t));
}


/*************************************************************************
** FUNKTION:	HaMemChangeStepNr
** ZWECK:	Veraendert HaMemStepNr um einen Wert und zeigt es an
** EINGABE:	Wert, der hinzuaddiert wird
*************************************************************************/
void HaMemChangeStepNr( i)
  int	i;
{  
  STRING	t;

  HaMemStepNr +=i;
  sprintf( t, " %d ", HaMemStepNr);
  XDrawImageString( MyDisplay, XtWindow( HaMemLabel),
  	BlackGC,
  	4, 12, t, strlen(t));
}



/*************************************************************************
** FUNKTION:	HaWinSayMemI
** ZWECK:	Setzt HaMemStepNr auf 0 zurueck und uebernimmt alle
**		Markierungen in den Speicher HaMem. 
** ANMERK: 	Markierungen nicht existierender Stellen sind -1
*************************************************************************/
void HaWinSayMemI( w, client, call)
  Widget	w;
  XtPointer	client, call;
{
  register int		i;
  register int		*m;
  register STELLE 	**s;

  HaMemSetStepNr( 0);
    
  for (i=0, s=SteStelle, m=HaMem; i<STEMAX; i++, s++, m++)
    if ( (*s) )
      *m = (*s)->Marke;
}  


/*************************************************************************
** FUNKTION:	HaWinSayMemO
** ZWECK:	Setzt HaMemStepNr auf 0 zurueck und schreibt alle
**		Markierungen aus dem Speicher HaMem in die Stellen zurueck.
** ANMERK: 	Markierungen nicht existierender Stellen sind -1
*************************************************************************/
void HaWinSayMemO( w, client, call)
  Widget	w;
  XtPointer	client, call;
{
  register int		i;
  register int		*m;
  register STELLE 	**s;

  HaMemSetStepNr( 0);
    
  for (i=0, s=SteStelle, m=HaMem; i<STEMAX; i++, s++, m++)
    if ( (*s) && (*m != -1) && ((*s)->Marke != *m) )
      HaSteMReplX( i, *m);

  HaKaRedraw();
  SimTouch();
}






