/************************************************************************
**
** FILE  : hamess.c
**
** AUTOR : Michael C. Ancutici
**	   Universitaet Stuttgart, Fakultaet Informatik
**
** DATUM : 14.03.93
**									
*************************************************************************/
#include	"hamess.h"
#include	"hawin.h"
#include	"misc.h"


#define	schreibe(w, text) XtVaSetValues( w , XtNlabel, text, NULL)
/*************************************************************************
** FUNKTION:	HaMessage
** ZWECK:	
** EINGABE:	
** AUSGABE:
** RETURN: 	
** ANMERK: 	
*************************************************************************/
void HaMessage( nr)	
  int nr;			/* Nummer der Meldung			*/
{
  char 		*t;
  static int 	on = FALSE;	/* Flag ob gerade was angezeigt	wird 	*/
  
  if (nr == HA_CLEAR && on) {	
    schreibe( HaStatLabel, "");
    on = FALSE;
  }
  else {
    switch (nr) {
      case HA_NO_FREE_STE:
	schreibe( HaStatLabel, "ERROR: Couldn't allocate enough memory for place data");
      break;
      case HA_OBJ_NEAR_OBJ:
	schreibe( HaStatLabel, "Too close to other object.");
      break;
      case HA_OBJ_NEAR_BORDER:
	schreibe( HaStatLabel, "Too close to margin.");
      break;
      case HA_NO_FREE_TRA:
	schreibe( HaStatLabel, "ERROR: Couldn't allocate enough memory for trans data.");
      break;
      case HA_NO_START_FOUND:
	schreibe( HaStatLabel, "Hmm.. Can't see here any place or trans.");
      break;
      case HA_NO_STELLE_FOUND:
	schreibe( HaStatLabel, "Hmm.. Can't see here any place.");
      break;
      case HA_NO_TRANS_FOUND:
	schreibe( HaStatLabel, "Hmm.. Can't see here any trans.");
      break;
      case HA_NO_FREE_KA:
	schreibe( HaStatLabel, "ERROR: Couldn't allocate enough memory for edge data.");
      break;
      case HA_KA_EXIST:
	schreibe( HaStatLabel, "Edge exist already.");
      break;
      case HA_ECKE_IN_KNOTEN:
	schreibe( HaStatLabel, "No fold within nodes.");
      break;
      case HA_FILE_SAVED:
	schreibe( HaStatLabel, "File saved.");
      break;
      case HA_SIM_NEED_T:
	schreibe( HaStatLabel, "Which trans should fire ?");
      break;
      case HA_SIM_SAY_DEAD:
	schreibe( HaStatLabel, "Hmm.. Net is DEAD.");
      break;
      case HA_BREAK_SET:
	schreibe( HaStatLabel, "Break condition(s) fulfilled.");
      break;
/*
      case HA_:
	schreibe( HaStatLabel, "");
      break;
*/
    }
    on = TRUE;
  }  	
}  




/*************************************************************************
** FUNKTION:	HaWinSetFilename
** ZWECK:	
** EINGABE:	
** AUSGABE:
** RETURN: 	
** ANMERK: 	
*************************************************************************/
void HaWinSetFilename( name)
  char 	*name;
{
  if (name)
    schreibe( HaFileLabel, name);
  else
    schreibe( HaFileLabel, "?.net");
}








