/************************************************************************
**
** FILE  : harefreshx.c
**
** ZWECK : 
**
** AUTOR : Michael C. Ancutici
**	   Universitaet Stuttgart, Fakultaet Informatik
**
** DATUM : 14.03.93
**									
*************************************************************************/
#include	"harefreshx.h"
#include	"ka.h"
#include	"hakadraw.h"
#include	"ste.h"
#include	"hatra.h"
#include	"haste.h"
#include	"haka.h"
#include	"hastemarke.h"
#include	"cell.h"
#include	"hatramisc.h"
#include	"hatraname.h"
#include	"hastemisc.h"
#include	"hastename.h"

#include <stdio.h>

#ifdef HALLO

/*************************************************************************
** FUNKTION:	RefreshKanten
** ZWECK:	Zeichnet ALLE Kanten, die mit einer Stelle verknuepft sind
**		in die HaGraphPixmap
** EINGABE:	
** AUSGABE:
** RETURN: 	
** ANMERK: 	
*************************************************************************/
static void RefreshKanten( SNr)
  int 	SNr;
{
  register int		i;
  register KANTE	**k;
  
  k = &(KaKante[ SNr][ 0]);
  
  for (i=0; i<TRAMAX; i++, k++) {
    if ( *(k++) )			/* existiert NachTrans ?	*/
      HaKaSTGDrawX( SNr, i);
    if (*k)
      HaKaTSGDrawX( SNr, i);		/* existiert NachStelle ?	*/
  }  	
}  




/*************************************************************************
** FUNKTION:	HaRefreshX
** ZWECK:	Zeichnet ALLE existierenden Objekte in die HaGraphPixmap
** EINGABE:	
** AUSGABE:
** RETURN: 	
** ANMERK: 	
*************************************************************************/
void HaRefreshX()
{
  register int		i;
  register STELLE	**s;
  register TRANSITION	**t;
  
  /**** ZUERST ALLE STELLEN MIT IHREN KANTEN ZEICHNEN *******************/
  s = SteStelle;
  
  for (i=0; i<STEMAX; i++, s++)
    if (*s) {					/* Stelle existiert	*/
      HaSteGDrawX( i);				/* Stelle zeichnen	*/
      RefreshKanten( i);  			/* Kanten zeichnen	*/
    }

  /**** ALLE TRANSITIONEN ZEICHNEN **************************************/
  t = TraTrans;
  
  for (i=0; i<TRAMAX; i++, t++)
    if (*t) 					/* Transition existiert	*/
      HaTraGDrawX( i);				/* Transition zeichnen	*/
}

#endif


/*************************************************************************
** FUNKTION:	HaRefreshXFromRL
** ZWECK:	
** EINGABE:	
** AUSGABE:
** RETURN: 	
** ANMERK: 	
*************************************************************************/
void HaRefreshXFromRL()
{
  OBJECT 	*p, *d;


  /**** IST REFRESH-LISTE LEER ? ****************************************/
  if ( !(p = CellRefreshList->next) )
    return;
  			
  CellRefreshList->next = NULL;		/* REFRESH-LISTE LEER SETZEN	*/
    
  while ( (d = p) ) {
    switch ( p->typ) {
      case CE_STELLE:
        HaSteDrawX( p->Nr1, SteGC);	/* STELLE ZEICHNEN		*/
        HaSteMDrawX( p->Nr1, MarkeGC);	/* MARKE ZEICHNEN		*/
      break;
      case CE_STE_NAME:
        HaSteNDrawX( p->Nr1, SteGC);	/* STELLEN-NAME ZEICHNEN	*/
      break;
      case CE_TRANSITION:
        HaTraDrawX( p->Nr1, TraGC);	/* TRANS ZEICHNEN		*/
      break;
      case CE_TRANS_NAME:
        HaTraNDrawX( p->Nr1, TraGC);		/* TRANS-NAME ZEICHNEN		*/
      break;
      case CE_ST_KANTE:
        HaKaSTDrawX( p->Nr1, p->Nr2, KaGC);	/* ST-KANTE ZEICHNEN		*/
      break;
      case CE_TS_KANTE:
        HaKaTSDrawX( p->Nr1, p->Nr2, KaGC);	/* TS-KANTE ZEICHNEN		*/
      break;
      case CE_ST_KANTE_DELTA:
        HaKaDDrawX( p->Nr1, p->Nr2, KaGC);	/* ST-KANTE-DELTA ZEICHNEN	*/
      break;
      case CE_TS_KANTE_DELTA:
        HaKaDDrawX( p->Nr1, p->Nr2, KaGC);	/* TS-KANTE-DELTA ZEICHNEN	*/
      break;
      case CE_TEXT:			/* TEXT ZEICHNEN		*/
      break;
    } 
    p = p->next;
    free( d);
  };
}




