/*********************************************************
**
** FILE:    netsize.h
**		Definition wichtiger Netzgroessen
**
** AUTOR:   Michael C. Ancutici		
**
** DATUM:   07.03.93
**
*********************************************************/

#ifndef	NETSIZE_H
#define NETSIZE_H


/****** NETZKAPAZITAET **************************************************/
#define TRAMAX		128	/* max. Anzahl Transitionen		*/
#define STEMAX		128	/* max. Anzahl Stellen			*/
#define TEMAX		30	/* max. Anzahl Textstrings		*/


/****** GROESSE DES ZEICHENFLAECHENFENSTERS *****************************/
#define VIEW_WIDTH	400
#define VIEW_HEIGHT	300


/****** GROESSE DER VIRTUELLEN ZEICHENFLAECHE ***************************/
#define PLANE_WIDTH	1024	/* Groesse x virtueller Zeichenflaeche	*/
				/* muss Vielfaches von CELLSIZE sein !	*/
#define PLANE_HEIGHT	1024	/* Groesse y virtueller Zeichenflaeche	*/
				/* muss Vielfaches von CELLSIZE sein !	*/


/****** GROESSE DER VIRTUELLEN ZEICHENFLAECHE IN BLOECKEN ***************/
#define CELLSIZE	8	/* Aufteilung der virtuellen Zeichen-	*/
				/* flaeche in Zellen dieser Groesse	*/

#define CELL_WIDTH	128	/* PLANE_WIDTH / CELLSIZE		*/
#define CELL_HEIGHT	128	/* PLANE_WIDTH / CELLSIZE		*/


/****** UMFANG EINER STELLE *********************************************/
#define HA_STE_RAD	16
#define	HA_STE_DM	32

/****** UMFANG EINER TRANSITION ****************************************/
#define HA_TRA_RAD	16
#define HA_TRA_DM	32
#define HA_TRA_DIA	10

#define CE_TRA_RAD	2
#define CE_TRA_DM	4
#define CE_TRA_DIA	1

#endif
