/************************************************************************
**
** FILE  : simaktiv.h
**
** ZWECK : 
**
** AUTOR : Michael C. Ancutici
**	   Universitaet Stuttgart, Fakultaet Informatik
**
** DATUM : 14.03.93
**									
*************************************************************************/
#ifndef SIMAKTIV_H
#define SIMAKTIV_H



/*************************************************************************
** FUNKTION:	SimAktiv 
** ZWECK:	Berechnet die Aktivitaet aller Transitionen bezueglich der 
**		Markierung in Marke. Die Anzahl der aktiven Transitionen
**		und die Summe der einzelnen Prioritaeten wird festgehalten.
** GLOBAL:	TransCond wird VOLLSTAENDIG neu berechnet.
**		nAktiv und SumPrio.
** ANMERK: 	Diese Funktion liefert eine nicht auf Konfliktfreiheit 
**		gepruefte Schaltmenge. Fuer den Seriellen Simulationsmodus
** 		ist sie ausreichend.
*************************************************************************/
extern void SimAktiv();



/*************************************************************************
** FUNKTION:	SimAktivOnTC
** ZWECK:	Berechnet die Aktivitaet bestimmter Transitionen bezueglich der 
**		Markierung in Marke. Die Anzahl der aktiven Transitionen
**		und die Summe der einzelnen Prioritaeten wird festgehalten.
** GLOBAL:	TransCond wird partiell neu berechnet. Betroffen sind die
**		Transitionen, die im Zustand AKTIV oder KONFLIKT sind.
**		nAktiv und SumPrio.
** ANMERK: 	Diese Funktion liefert eine nicht auf Konfliktfreiheit 
**		gepruefte Schaltmenge. Es muss ein SimAktiv vorausgegangen
**		sein. 
*************************************************************************/
extern void SimAktivOnTC();


#endif