/************************************************************************
**
** FILE  : simbreak.h
**
** ZWECK : 
**
** AUTOR : Michael C. Ancutici
**	   Universitaet Stuttgart, Fakultaet Informatik
**
** DATUM : 14.03.93
**									
*************************************************************************/
#ifndef SIMBREAK_H
#define SIMBREAK_H



/*************************************************************************
** FUNKTION:	SimBreakInit
** ZWECK:	Initialisiert BreakList mit einem Startobjekt.
** GLOBAL:	SimBreakList zeigt auf ein Startobjekt.
** ANMERK: 	Das Startobjekt hat keine weitere Bedeutung ausser
**		dass es Einfuege und Loeschoperationen vereinfacht.
*************************************************************************/
void SimBreakInit();




/*************************************************************************
** FUNKTION:	SimBreakAddBL
** ZWECK:	Fuegt eine Stelle oder eine Transition in die
**		BreakList ein, FALLS sie noch nicht drin sind.
** EINGABE:	Typ und Nummer des einzufuegenden Objektes
** ANMERK: 	Objekt wird am Ende eingefuegt. BreakList hat somit
**		eine aufsteigende Ordnung.
*************************************************************************/
void SimBreakAddBL( char, int);




/*************************************************************************
** FUNKTION:	SimBreakClearBL
** ZWECK:	Loescht BreakList.
** GLOBAL:	BreakList wird auf Startobjekt reduziert.
*************************************************************************/
void SimBreakClearBL();




#endif