/************************************************************************
**
** FILE  : simget.h
**
** ZWECK : 
**
** AUTOR : Michael C. Ancutici
**	   Universitaet Stuttgart, Fakultaet Informatik
**
** DATUM : 14.03.93
**									
*************************************************************************/
#ifndef SIMGET_H
#define SIMGET_H




/*************************************************************************
** FUNKTION:	SimGetInit
** ZWECK:	Initialisiert Zufallszahlengenerator.
*************************************************************************/
extern void SimGetInit();



/*************************************************************************
** FUNKTION:	SimGetRandomT
** ZWECK:	Waehlt aus einer gewuenschten Menge eine Transition aus 
**		Bei der Menge kann es sich um AKTIVe oder KONFLIKTbehaftete
**		Transitionen handeln. Die Auswahl ist zufaellig. Die Prioritaeten
**		der Transitionen dienen als Gewichte.
** EINGABE:	Typ der Menge: AKTIV oder KONFLIKT
** RETURN: 	Nr der ausgewaehlten Transition.
** ANMERK: 	ACHTUNG: 
**		1. TransCond und SumPrio muessen aktuell sein.
**		2. Es muss mind 1 aktive Transition existieren.
**		3. for-Schleife anthaelt KEINE Abbruchbedingung !
**		   falls 1. und 2. nicht zutrifft, knallt es.
*************************************************************************/
extern int SimGetRandomT( char);




/*************************************************************************
** FUNKTION:	SimGetFirstT
** ZWECK:	Liefert die Nummer der ersten AKTIVen oder KONFLIKTbehafteten
**		Transition. 
** EINGABE:	Typ der Aktivitaet.
** RETURN: 	TNr
*************************************************************************/
extern int SimGetFirstT( char);


#endif
