/************************************************************************
**
** FILE  : simkon.h
**
** ZWECK : 
**
** AUTOR : Michael C. Ancutici
**	   Universitaet Stuttgart, Fakultaet Informatik
**
** DATUM : 14.03.93
**									
*************************************************************************/
#ifndef SIMKON_H
#define SIMKON_H


/*************************************************************************
** FUNKTION:	SimKonflikt
** ZWECK:	Markiert in TransCond alle AKTIVen Transitionen, die an einem
**		Verzweigungskonflikt beteiligt sind. 
** GLOBAL:	TransCond wird veraendert und der Zaehler nKonflikt gesetzt.
**		sumPrio ueber KONFLIKTbehaftete Transitionen
*************************************************************************/
extern void SimKonflikt();



/*************************************************************************
** FUNKTION:	SimRemoveKonMenge
** ZWECK:	Versetzt alle Transitionen in den Zustand TOT, die in 
**		denselben Konfliktmengen enthalten sind wie eine bestimmte
**		Transition.
** EINGABE:	Nummer der Transition.
** GLOBAL: 	TransCond wird geaendert.
*************************************************************************/
extern void SimRemoveKonMenge( int);



#endif